## gtk4 4.6.9+ds

=== meson_options.txt ===
# GDK backends

option('x11-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the X11 gdk backend (only when building on Unix)')

option('wayland-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the wayland gdk backend (only when building on Unix except for macOS)')

option('broadway-backend',
       type: 'boolean',
       value: false,
       description : 'Enable the broadway (HTML5) gdk backend')

option('win32-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the Windows gdk backend (only when building on Windows)')

option('macos-backend',
       type: 'boolean',
       value: true,
       description : 'Enable the macOS gdk backend (only when building on macOS)')

# Media backends
# For distros: GTK guarantees support for WebM video (VP8 and VP9), so a supported build
# should provide that.

option('media-ffmpeg',
       type: 'feature',
       value: 'disabled',
       description : 'Build the experimental ffmpeg media backend')

option('media-gstreamer',
       type: 'feature',
       value: 'enabled',
       description : 'Build the gstreamer media backend')

# Print backends

option('print-cups',
       type: 'feature',
       value: 'auto',
       description : 'Build the cups print backend')

# Optional features

option('vulkan',
       type: 'feature',
       value: 'disabled',
       description : 'Enable support for the experimental Vulkan graphics API')

option('cloudproviders',
       type: 'feature',
       value: 'disabled',
       description : 'Enable the cloudproviders support')

option('sysprof',
       type: 'feature',
       value: 'disabled',
       description : 'include tracing support for sysprof')

option('tracker',
       type: 'feature',
       value: 'disabled',
       description : 'Enable Tracker3 filechooser search')

option('colord',
       type: 'feature',
       value: 'disabled',
       description : 'Build colord support for the CUPS printing backend')

option('f16c',
       type: 'feature',
       value: 'enabled',
       description: 'Enable F16C fast paths (requires F16C)')

# Documentation and introspection

option('gtk_doc',
       type: 'boolean',
       value: false,
       description : 'Build API reference and tools documentation')

option('man-pages',
       type: 'boolean',
       value: false,
       description : 'Build man pages for installed tools')

option('introspection',
       type: 'feature',
       value: 'auto',
       yield: true,
       description : 'Build introspection data (requires gobject-introspection)')

# Demos, examples and tests

option('demos',
       type: 'boolean',
       value: true,
       description : 'Build demo programs')

option('profile',
       type: 'combo',
       choices: [ 'default', 'devel' ],
       value: 'default',
       description : 'Profile to use for demos')

option('build-examples',
       type: 'boolean',
       value: true,
       description : 'Build examples')

option('build-tests',
       type: 'boolean',
       value: true,
       description : 'Build tests')

option('install-tests',
       type: 'boolean',
       value: false,
       description : 'Install tests')

=== debian/changelog ===
gtk4 (4.6.9+ds-0ubuntu0.22.04.2) jammy-security; urgency=medium

  * No-change rebuild in the -security pocket.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 07 May 2024 17:32:05 -0400

gtk4 (4.6.9+ds-0ubuntu0.22.04.1) jammy; urgency=medium

  * New upstream release (LP: #2028005)
  * debian/gbp.conf: Use upstream/4.6.x for upstream branch
  * debian/patches: Refresh git indexes
  * debian/patches: Properly handle gtk scale adjustment property (LP: #2027986)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Mon, 17 Jul 2023 19:53:19 +0200

gtk4 (4.6.6+ds-0ubuntu1) jammy; urgency=medium

  * New upstream release (LP: #1980742)
  * Build-Depend on dh-sequence-translations
    - Needed to fix missing translations and RTL support (LP: #1947698)
  * debian/rules: Handle the second translation template for dh-translations

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 05 Jul 2022 14:21:19 -0400

gtk4 (4.6.5+ds-0ubuntu1) jammy; urgency=medium

  * New upstream release (LP: #1976500)
     - Fixes file chooser getting bigger each time it opens (LP: #1971112)
  * Build-Depend on gi-docgen
  * Drop patches applied in new release

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 01 Jun 2022 11:36:03 -0400

gtk4 (4.6.3+ds1-0ubuntu1) jammy; urgency=medium

  [ Jeremy Bicha ]
  * New upstream bugfix release (LP: #1973219)
  * Cherry-pick additional bug fixes:
    - Fix text view scrolling with mutter 42.1 (LP: #1972722)
    - Work around infinite loop in box allocation (Closes: #1010547)
    - Make it easier to select the current folder with a file chooser
    - Fix saving into a subdirectory with a file chooser
    - Fix an invalid format string with EGL support

  [ Simon McVittie ]
  * d/log-reftests.py: Update names of GSK renderers
  * d/rules, d/run-tests.sh: Add infrastructure to ignore failing GSK tests
  * Ignore unaligned-offscreen GSK comparison test

 -- Jeremy Bicha <jbicha@ubuntu.com>  Thu, 12 May 2022 11:41:48 -0400

gtk4 (4.6.2+ds-1ubuntu3) jammy; urgency=medium

  * Cherry-pick filechooser-Small-fix-for-save-mode.patch:
    Fix saving files to a folder that doesn't have any files in it
    (LP: #1969622)

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 20 Apr 2022 09:37:57 -0400

=== debian/control ===
Source: gtk4
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Simon McVittie <smcv@debian.org>, Jeremy Bicha <jbicha@debian.org>
Build-Depends: adwaita-icon-theme <!nocheck>,
               at-spi2-core <!nocheck>,
               dbus <!nocheck>,
               debhelper-compat (= 13),
               dh-sequence-translations,
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.17.14),
               fonts-cantarell <!nocheck>,
               fonts-dejavu-core <!nocheck>,
               gnome-pkg-tools (>= 0.11),
               gobject-introspection (>= 1.41.3),
               gsettings-desktop-schemas <!nocheck>,
               iso-codes <!nocheck>,
               libavcodec-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
               libavfilter-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
               libavformat-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
               libavutil-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
               libcairo2-dev (>= 1.14.0),
               libcolord-dev (>= 0.1.9),
               libcloudproviders-dev (>= 0.3.1),
               libcups2-dev (>= 2.0),
               libegl1-mesa-dev [linux-any],
               libepoxy-dev,
               libfontconfig1-dev,
               libfribidi-dev (>= 0.19.7),
               libgdk-pixbuf-2.0-dev (>= 2.30.0),
               libgirepository1.0-dev (>= 1.39.0),
               libglib2.0-dev (>= 2.66.0),
               libgraphene-1.0-dev (>= 1.10.4~),
               libgstreamer1.0-dev (>= 1.12.3),
               libgstreamer-plugins-bad1.0-dev (>= 1.12.3),
               libharfbuzz-dev (>= 2.1.0),
               libjpeg-dev,
               libjson-glib-dev:native,
               libpango1.0-dev (>= 1.50.0),
               libpng-dev,
               libpolkit-gobject-1-dev (>= 0.105) [linux-any],
               librsvg2-common <!nocheck>,
               librsvg2-dev (>= 2.52.0),
               libswscale-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
               libsysprof-capture-4-dev (>= 3.40.1) [linux-any],
               libtiff-dev,
               libvulkan-dev [linux-any],
               libwayland-dev (>= 1.20.0) [linux-any],
               libx11-dev,
               libxcomposite-dev,
               libxcursor-dev,
               libxdamage-dev,
               libxext-dev,
               libxfixes-dev,
               libxi-dev,
               libxinerama-dev,
               libxkbcommon-dev (>= 0.2.0),
               libxkbfile-dev,
               libxml2-utils,
               libxrandr-dev (>= 2:1.5.0),
               locales <!nocheck> | locales-all <!nocheck>,
               meson (>= 0.59),
               pkg-config,
               python3-docutils <!nodoc>,
               python3-gi (>= 3.40) <!nocheck>,
               sassc,
               ttf-bitstream-vera <!nocheck>,
               wayland-protocols (>= 1.23) [linux-any],
               weston [linux-any] <!nocheck>,
               xauth <!nocheck>,
               xsltproc,
               xvfb <!nocheck>,
Build-Depends-Indep: libcairo2-doc,
                     gi-docgen,
                     libglib2.0-doc,
                     libpango1.0-doc,
                     pandoc,
                     python3 (>= 3.6) <!nodoc>,
                     python3-jinja2 <!nodoc>,
                     python3-markdown <!nodoc>,
                     python3-pygments <!nodoc>,
                     python3-toml <!nodoc>,
                     python3-typogrify <!nodoc>,
Rules-Requires-Root: no
Standards-Version: 4.6.0
XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4
XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git
Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4/-/tree/ubuntu/jammy
Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git -b ubuntu/jammy
Homepage: https://www.gtk.org/

Package: libgtk-4-1
Architecture: any
Multi-Arch: same
Depends: adwaita-icon-theme,
         hicolor-icon-theme,
         shared-mime-info,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common (>= ${source:Version})
Provides: gtk4-binver-4.0.0
Recommends: libgtk-4-bin,
            iso-codes,
            librsvg2-common (>= 2.52.0),
Suggests: gvfs,
          libgtk-4-media-gstreamer | libgtk-4-media-ffmpeg,
Breaks: libgtk-4-0 (<< 4.0.0),
Replaces: libgtk-4-0 (<< 4.0.0),
Pre-Depends: ${misc:Pre-Depends}
Description: GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the shared libraries.

Package: libgtk-4-1-udeb
Build-Profiles: <!noudeb>
Package-Type: udeb
Section: debian-installer
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: gtk4-binver-4.0.0
Description: GTK graphical user interface library - minimal runtime
 This is a udeb, or a microdeb, for the debian-installer.
 .
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the minimal runtime library using X11 needed
 by the Debian installer.

Package: libgtk-4-common
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libgtk-4-1
Description: common files for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the common files which the libraries need.

Package: libgtk-4-bin
Section: misc
Architecture: any
Multi-Arch: foreign
Depends: gtk-update-icon-cache,
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common (>= ${source:Version}),
         libgtk-4-1 (>= ${source:Version})
Breaks: gtk-4-examples (<< 3.96.0-3~)
Replaces: gtk-4-examples (<< 3.96.0-3~)
Description: programs for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the utilities which are used by the libraries
 and other packages.

Package: libgtk-4-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: gir1.2-gtk-4.0 (= ${binary:Version}),
         libcairo2-dev (>= 1.14.0),
         libegl1-mesa-dev [linux-any],
         libepoxy-dev (>= 1.0),
         libfontconfig1-dev,
         libgdk-pixbuf-2.0-dev (>= 2.30.0),
         libglib2.0-dev (>= 2.66.0),
         libgraphene-1.0-dev (>= 1.9.1),
         libpango1.0-dev (>= 1.50.0),
         libwayland-dev (>= 1.16.91) [linux-any],
         libx11-dev,
         libxcomposite-dev,
         libxcursor-dev,
         libxdamage-dev,
         libxext-dev,
         libxfixes-dev,
         libxi-dev,
         libxinerama-dev,
         libxkbcommon-dev,
         libxrandr-dev,
         libvulkan-dev [linux-any],
         pkg-config,
         wayland-protocols (>= 1.21) [linux-any],
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common,
         libgtk-4-1 (= ${binary:Version})
Suggests: libgtk-4-doc,
          gtk-4-examples
Description: development files for the GTK library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the header and development files which are
 needed for building GTK applications.

Package: libgtk-4-doc
Build-Profiles: <!nodoc>
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libglib2.0-doc,
            libpango1.0-doc
Suggests: devhelp
Description: documentation for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the HTML documentation for the GTK library
 in /usr/share/doc/libgtk-4-doc/ .

Package: libgtk-4-media-gstreamer
Section: x11
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: GStreamer media backend for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the media module that uses GStreamer as backend.

Package: libgtk-4-media-ffmpeg
Build-Profiles: <pkg.gtk4.ffmpeg>
Section: x11
Architecture: amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: FFmpeg media backend for the GTK graphical user interface library
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the media module that uses FFmpeg as backend.
 This module is considered incomplete and experimental, and using the
 libgtk-4-media-gstreamer module instead is recommended.

Package: gtk-4-examples
Build-Profiles: <!noinsttest>
Section: x11
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-1 (= ${binary:Version})
Recommends: fonts-cantarell,
            librsvg2-common (>= 2.52.0),
Description: example files for GTK 4
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains the example files and a demonstration program
 for GTK4. It also contains the installed tests.

Package: gtk-4-tests
Build-Profiles: <!noinsttest>
Section: x11
Architecture: any
Depends: iso-codes,
         librsvg2-common (>= 2.52.0),
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-1 (= ${binary:Version}),
Recommends: gnome-desktop-testing,
            locales | locales-all,
Description: "as-installed" tests for GTK 4
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .
 This package contains installable test programs, primarily for use with
 autopkgtest.

Package: gir1.2-gtk-4.0
Section: introspection
Architecture: any
Multi-Arch: same
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
         libgtk-4-common
Breaks: python-gi (<< 3.18),
        python3-gi (<< 3.18)
Provides: gir1.2-gdk-4.0 (= ${binary:Version}),
          gir1.2-gdkwayland-4.0 (= ${binary:Version}) [linux-any],
          gir1.2-gdkx11-4.0 (= ${binary:Version}),
          gir1.2-gsk-4.0 (= ${binary:Version})
Description: GTK graphical user interface library -- gir bindings
 GTK is a multi-platform toolkit for creating graphical user
 interfaces. Offering a complete set of widgets, GTK is suitable
 for projects ranging from small one-off tools to complete application
 suites.
 .

=== debian/rules ===
#!/usr/bin/make -f

DISABLE_UPDATE_UPLOADERS = 1
include /usr/share/gnome-pkg-tools/1/rules/uploaders.mk
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

dh_options =
built_binaries := $(shell dh_listpackages)
all_binaries := $(shell sed -ne 's/^Package: *//p' < debian/control)

# Ensure the build aborts when there are still references to undefined symbols
LDFLAGS += -Wl,-z,defs

# Make the linker work a bit harder so dynamic loading can be done faster
LDFLAGS += -Wl,-O1

export APIVER := 4
export SONAME := 1

export LIBDIR := usr/lib/$(DEB_HOST_MULTIARCH)

# earliest version that this release has backwards binary compatibility for
export GTK_BINARY_VERSION := 4.0.0

# Gtk binary version virtual Provide
export GTK_BINVER_DEP := gtk$(APIVER)-binver-$(GTK_BINARY_VERSION)

# relative base directory for configuration
export CONFDIR := etc/gtk-4.0

# relative base directory for all types of modules
export MODULES_BASE_PATH := $(LIBDIR)/gtk-4.0/$(GTK_BINARY_VERSION)

# package names
export SHARED_PKG := libgtk-$(APIVER)-$(SONAME)
export COMMON_PKG := libgtk-$(APIVER)-common
export DEV_PKG := libgtk-$(APIVER)-dev
export UDEB_PKG := $(SHARED_PKG)-udeb
export DOC_PKG := libgtk-$(APIVER)-doc
export BIN_PKG := libgtk-$(APIVER)-bin
export MEDIA_GSTREAMER_PKG := libgtk-$(APIVER)-media-gstreamer
export MEDIA_FFMPEG_PKG := libgtk-$(APIVER)-media-ffmpeg
export EXAMPLES_PKG := gtk-$(APIVER)-examples
export TESTS_PKG := gtk-$(APIVER)-tests

# files larger than 4k in size will be compressed by dh_compress
# so append a .gz suffix to avoid dangling symlinks
export README_MD_MAYBE_GZ := README.md$(shell find -maxdepth 1 -size +4k -name README.md -exec echo ".gz" \;)

# macro computing the list of 'debian/<pkg>.*" files which have a
# corresponding ".in" file; pass the list of packages in $(1)
dh_subst_files = $(patsubst %.in,%,$(wildcard $(addprefix debian/, $(addsuffix *.in, $(1)))))

debian/%: debian/%.in
	dh_testdir
	sed \
		-e "s#@SONAME@#$(SONAME)#g" \
		-e "s#@APIVER@#$(APIVER)#g" \
		-e "s#@GTK_BINVER_DEP@#$(GTK_BINVER_DEP)#g" \
		-e "s#@SHARED_PKG@#$(SHARED_PKG)#g" \
		-e "s#@COMMON_PKG@#$(COMMON_PKG)#g" \
		-e "s#@DEV_PKG@#$(DEV_PKG)#g" \
		-e "s#@UDEB_PKG@#$(UDEB_PKG)#g" \
		-e "s#@DOC_PKG@#$(DOC_PKG)#g" \
		-e "s#@BIN_PKG@#$(BIN_PKG)#g" \
		-e "s#@MEDIA_GSTREAMER_PKG@#$(MEDIA_GSTREAMER_PKG)#g" \
		-e "s#@MEDIA_FFMPEG_PKG@#$(MEDIA_FFMPEG_PKG)#g" \
		-e "s#@EXAMPLES_PKG@#$(EXAMPLES_PKG)#g" \
		-e "s#@TESTS_PKG@#$(TESTS_PKG)#g" \
		-e "s#@GNOME_TEAM@#$(UPLOADERS)#g" \
		-e "s#@LIBDIR@#$(LIBDIR)#g" \
		-e "s#@MODULES_BASE_PATH@#$(MODULES_BASE_PATH)#g" \
		-e "s#@DEB_VERSION_UPSTREAM@#$(DEB_VERSION_UPSTREAM)#g" \
		$@.in > $@

configure_flags_common = \
	--libdir=/$(LIBDIR) \
	${NULL}

configure_flags_deb = \
	-Dauto_features=enabled \
	-Dbroadway-backend=false \
	-Dx11-backend=true \
	${NULL}

ifeq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
configure_flags_deb += -Dcolord=enabled
else
configure_flags_deb += -Dcolord=disabled
endif

ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
configure_flags_deb += -Dman-pages=true
else
configure_flags_deb += -Dman-pages=false
endif

ifeq (linux,$(DEB_HOST_ARCH_OS))
configure_flags_deb += -Dsysprof=enabled
configure_flags_deb += -Dwayland-backend=true
else
configure_flags_deb += -Dsysprof=disabled
configure_flags_deb += -Dvulkan=disabled
configure_flags_deb += -Dwayland-backend=false
endif

ifeq ($(filter %-doc,$(built_binaries)),)
configure_flags_deb += -Dgtk_doc=false
else
configure_flags_deb += -Dgtk_doc=true
endif

ifeq ($(filter %-examples,$(built_binaries)),)
configure_flags_deb += -Dbuild-examples=false
configure_flags_deb += -Ddemos=false
else
configure_flags_deb += -Dbuild-examples=true
configure_flags_deb += -Ddemos=true
endif

ifeq ($(filter %-tests,$(built_binaries)),)
configure_flags_deb += -Dinstall-tests=false
else
configure_flags_deb += -Dinstall-tests=true
endif

# Upstream consider the ffmpeg backend to be experimental, let's not
# build that by default.
ifeq ($(filter $(MEDIA_FFMPEG_PKG),$(built_binaries)),)
configure_flags_deb += -Dmedia-ffmpeg=disabled
else
configure_flags_deb += -Dmedia-ffmpeg=enabled
endif

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes), yes)
# Not in main repository
configure_flags_deb += -Dcloudproviders=disabled
else
configure_flags_deb += -Dcloudproviders=enabled
endif

configure_flags_udeb = \
	-Dauto_features=disabled \
	-Dbroadway-backend=false \
	-Dbuild-examples=false \
	-Ddemos=false \
	-Dbuild-tests=false \
	-Dinstall-tests=false \
	-Dmedia-gstreamer=disabled \
	-Dwayland-backend=false \
	-Dx11-backend=true \
	$(NULL)

%:
	dh $@ --with gir --buildsystem=meson $(dh_options)

override_dh_clean: debian/control
	# gross kludge to force control generation with the %.in target
	touch debian/control.in
	rm -f $(call dh_subst_files,$(all_binaries))
	rm -rf debian/build debian/install
	# Rebuild the CSS from source. Note that gtk.css is hand-written,
	# not generated, so don't delete that one.
	rm -f gtk/theme/Default/Default-*.css
	dh_clean

# Add dependencies to generate files from the debian/*.in ones
override_dh_auto_build: $(call dh_subst_files,$(all_binaries))

override_dh_auto_build: rebuild-emoji
rebuild-emoji:
	gcc -o debian/convert-emoji gtk/emoji/convert-emoji.c `pkg-config --cflags --libs json-glib-1.0`
	set -eu; for input in debian/missing-sources/emojibase/packages/data/??/data.raw.json; do \
		lang="$$(echo "$$input" | sed -ne 's,^.*/\([a-z][a-z]\)/data.raw.json$$,\1,p')"; \
		output="gtk/emoji/$$lang.data"; \
		test -f "$$output" || continue; \
		debian/convert-emoji "$$input" "$$output"; \
	done

override_dh_auto_configure: debian/control
	dh_auto_configure \
		--builddirectory=debian/build/deb \
		-- \
		$(configure_flags_common) \
		$(configure_flags_deb) \
		$(NULL)
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_configure \
		--builddirectory=debian/build/udeb \
		-- \
		$(configure_flags_common) \
		$(configure_flags_udeb) \
		$(NULL)
endif

override_dh_auto_build:
	dh_auto_build --builddirectory=debian/build/deb
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_build --builddirectory=debian/build/udeb
endif

test_backends = x11
test_timeout_multiplier = 1

ifeq (linux,$(DEB_HOST_ARCH_OS))
	test_backends += wayland
endif

ifneq ($(filter arm hppa mips% sparc%,$(DEB_HOST_ARCH_CPU)),)
$(info Slow architecture detected, increasing test timeout)
test_timeout_multiplier = 10
endif

ifneq ($(filter m68k riscv64 sh4,$(DEB_HOST_ARCH_CPU)),)
$(info Architecture with qemu buildds detected, increasing test timeout a lot)
test_timeout_multiplier = 20
endif

fuzzy_gsk_compare = \
	$(NULL)

ignore_gsk_compare = \
	unaligned-offscreen \
	$(NULL)

xfail_gsk_compare = \
	$(NULL)

fuzzy_reftests = \
	border-image-url \
	label-attribute-preference \
	label-wrap-justify \
	pseudoclass-on-box \
	quit-mnemonic \
	$(NULL)

ignore_reftests = \
	$(NULL)

xfail_reftests = \
	label-sizing \
	sizegroups-evolution-identity-page \
	$(NULL)

skipped_suites = \
	$(NULL)

# TODO: Known failures: https://gitlab.gnome.org/GNOME/gtk/-/issues/4110
# s390x: many (endianness?)
ifeq (big,$(DEB_HOST_ARCH_ENDIAN))
	skipped_suites += \
		gsk-compare-broadway \
		gsk-compare-gl \
		gsk-compare-ngl \
		$(NULL)
endif

override_dh_auto_test:
	set -e; for backend in $(test_backends); do \
		env BUILDDIR=debian/build/deb \
			FUZZY_GSK_COMPARE="$(fuzzy_gsk_compare)" \
			FUZZY_REFTESTS="$(fuzzy_reftests)" \
			IGNORE_GSK_COMPARE="$(ignore_gsk_compare)" \
			IGNORE_REFTESTS="$(ignore_reftests)" \
			XFAIL_GSK_COMPARE="$(xfail_gsk_compare)" \
			XFAIL_REFTESTS="$(xfail_reftests)" \
			BACKEND=$$backend \
				debian/run-tests.sh -t $(test_timeout_multiplier) \
					$(addprefix --no-suite=,$(skipped_suites)); \
	done

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build/deb --destdir=debian/install/deb
ifneq ($(filter %-udeb,$(built_binaries)),)
	dh_auto_install --builddirectory=debian/build/udeb --destdir=debian/install/udeb
endif

override_dh_install:

## gtk4 4.8.1+ds

=== debian/changelog ===
gtk4 (4.8.1+ds-1ubuntu1) kinetic; urgency=medium

  * Sync with Debian. Remaining changes:
    - debian/tests:
      + include the memorytexture test in the flaky set, it has been unreliable
    - debian/control:
      + Build-Depend on dh-sequence-translations

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 19 Sep 2022 16:39:04 -0400

gtk4 (4.8.1+ds-1) unstable; urgency=medium

  * New upstream release
  * debian/libgtk-4-1.symbols.in: Add a new symbol
  * d/control.in: Replace transitional libfontconfig1-dev with
    libfontconfig-dev
  * d/missing-sources: Update for upstream updates to Compose data
  * d/p/gdkevents-Don-t-ignore-modifiers-that-are-not-currently-a.patch:
    Add proposed patch to fix keyboard shortcuts with X11 backend
    (Closes: #1016927)
  * d/p/build-Use-more-conservative-GResource-embedding-on-non-x8.patch:
    Update patch for GResource embedding based on upstream feedback

 -- Simon McVittie <smcv@debian.org>  Sat, 17 Sep 2022 22:23:08 +0100

gtk4 (4.7.2+ds-3) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/libgtk-4-1.symbols.in: Mark more Wayland symbols as Linux-specific
  * Build-depend on dh-exec
  * Avoid trying to install Wayland documentation on non-Linux
    (Closes: #1017866)

  [ Jeremy Bicha ]
  * Release to unstable

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 21 Aug 2022 17:40:46 -0400

gtk4 (4.7.2+ds-2ubuntu1) kinetic; urgency=medium

  * Sync with Debian. Remaining changes:
    - debian/tests:
      + include the memorytexture test in the flaky set, it has been unreliable
    - debian/control:
      + Build-Depend on dh-sequence-translations
  * Drop the debian/rules translation override since there is only one
    translation template now

 -- Jeremy Bicha <jbicha@ubuntu.com>  Thu, 18 Aug 2022 22:34:45 -0400

gtk4 (4.7.2+ds-2) experimental; urgency=medium

  * Merge packaging changes from unstable

 -- Simon McVittie <smcv@debian.org>  Tue, 16 Aug 2022 11:24:01 +0100

gtk4 (4.6.6+ds-3ubuntu1) kinetic; urgency=medium

  * Sync with Debian. Remaining changes:
    - debian/tests:
      + include the memorytexture test in the flaky set, it has been unreliable
    - debian/control:
      + Build-Depend on dh-sequence-translations
    - debian/rules: Handle the 2nd translation template file.
      This override can be dropped with 4.7.1

 -- Jesús Soto <jesus.soto@canonical.com>  Tue, 16 Aug 2022 09:49:05 -0500

gtk4 (4.6.6+ds-3) unstable; urgency=medium

  * Branch 4.6.x for unstable
  * d/rules: Force softpipe OpenGL driver on mips* architectures.
    This is a workaround for misrendering and crashes when the buildds run
    tests under llvmpipe on these architectures (see #993550, #1003348,
    #1010838).
  * d/p/debian/Skip-some-known-failing-tests-on-mips-family-architecture.patch:
    Remove patch, stop skipping tests that (should) pass on mips*el when
    we force softpipe.
  * d/p/Work-around-1014417-in-Meson.patch:
    Remove workaround for a Meson 0.63.0 bug that was fixed in 0.63.1
  * d/p/build-Add-an-option-to-use-more-conservative-GResource-em.patch:
    Add a build option to disable the GResource fast-path, and disable it.
    It isn't reliable on non-mainstream architectures, and the compile time
    improvement is not significant if we're compiling all of GTK anyway.
  * d/rules: Enable broadway backend for the .deb build (but not the udeb).
    This is apparently used by Cambalache and Deckard, and also the
    Pidgin unit tests. (Closes: #994944)

 -- Simon McVittie <smcv@debian.org>  Tue, 16 Aug 2022 09:23:59 +0100

gtk4 (4.7.2+ds-1) experimental; urgency=medium

  * New upstream development release
    - Fix crashes involving GL/GLES version selection on PinePhone
      (Closes: #1009917)
  * Repack with wayland and wayland-protocols subprojects omitted.
    The versions in unstable are sufficiently new.
  * d/control.in: Update dependency versions
  * d/copyright: Update
  * Refresh patch series
  * Skip inscription-markup.ui reftest for now.
    The whole thing is rendered 1px offset from where it should be, which is
    not a serious problem for practical use of GTK, but makes the tests fail.
  * d/gtk-4-examples.install: Include the new NodeEditor demo
  * Update symbols file for new ABI

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Aug 2022 11:46:07 +0100

gtk4 (4.6.6+ds-2) unstable; urgency=medium

  [ Evangelos Ribeiro Tzaras ]
  * Drop erroneous !nocheck annotation from python3-gi Build-Depends
    (Closes: #1014878)

  [ Simon McVittie ]
  * Add temporary patch to work around #1014417 in Meson
  * Standards-Version: 4.6.1 (no changes required)
  * Migrate GLib 2.68.0 build-dependency from d/control to d/control.in
  * d/copyright: Drop unused GPL license stanzas
  * d/gtk-4-tests.lintian-overrides: Update syntax for current Lintian

 -- Simon McVittie <smcv@debian.org>  Mon, 08 Aug 2022 19:22:54 +0100
 
 gtk4 (4.6.6+ds-1ubuntu1) kinetic; urgency=medium

  * Sync with Debian. Remaining changes:
    - debian/tests:
      + include the memorytexture test in the flaky set, it has been unreliable
    - debian/control:
      + Build-Depend on dh-sequence-translations
    - debian/rules: Handle the 2nd translation template file.
      This override can be dropped with 4.7.1

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 05 Jul 2022 14:09:40 -0400

gtk4 (4.6.6+ds-1) unstable; urgency=medium

  [ Jeremy Bicha ]
  * New upstream release (LP: #1980742)

  [ Simon McVittie ]
  * d/tests/installed-tests: Fail on unset variable references
  * d/tests/installed-tests: Fail if no tests are found

  [ Evangelos Ribeiro Tzaras ]
  * Bump required glib build dependency

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 05 Jul 2022 11:24:34 -0400

gtk4 (4.6.5+ds-1ubuntu6) kinetic; urgency=medium

  * debian/rules:
    - use the make-pot script instead of the  --enable-features=Vulkan
      rule which seems to not work as intended

 -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 04 Jul 2022 13:47:15 +0200



=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Simon McVittie <smcv@debian.org>, Jeremy Bicha <jbicha@debian.org>
+Uploaders: Simon McVittie <smcv@debian.org>, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>, Jeremy Bicha <jbicha@ubuntu.com>
 Build-Depends: adwaita-icon-theme <!nocheck>,
                at-spi2-core <!nocheck>,
                dbus <!nocheck>,
                debhelper-compat (= 13),
+               dh-exec,
                dh-sequence-translations,
                docbook-xml,
                docbook-xsl,
@@ -19,6 +20,7 @@
                gsettings-desktop-schemas <!nocheck>,
                iso-codes <!nocheck>,
                libavcodec-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
+               libavdevice-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
                libavfilter-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
                libavformat-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
                libavutil-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
@@ -28,27 +30,28 @@
                libcups2-dev (>= 2.0),
                libegl1-mesa-dev [linux-any],
                libepoxy-dev,
-               libfontconfig1-dev,
+               libfontconfig-dev,
                libfribidi-dev (>= 0.19.7),
                libgdk-pixbuf-2.0-dev (>= 2.30.0),
                libgirepository1.0-dev (>= 1.39.0),
-               libglib2.0-dev (>= 2.66.0),
+               libglib2.0-dev (>= 2.68.0),
                libgraphene-1.0-dev (>= 1.10.4~),
                libgstreamer1.0-dev (>= 1.12.3),
                libgstreamer-plugins-bad1.0-dev (>= 1.12.3),
-               libharfbuzz-dev (>= 2.1.0),
+               libharfbuzz-dev (>= 2.6.0),
                libjpeg-dev,
                libjson-glib-dev:native,
                libpango1.0-dev (>= 1.50.0),
                libpng-dev,
                libpolkit-gobject-1-dev (>= 0.105) [linux-any],
-               librsvg2-common <!nocheck>,
-               librsvg2-dev (>= 2.52.0),
+               librsvg2-common [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64 riscv64 sparc64 x32] <!nocheck>,
+               librsvg2-dev (>= 2.52.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64 riscv64 sparc64 x32],
+               libswresample-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
                libswscale-dev (>= 7:4.1.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x],
                libsysprof-capture-4-dev (>= 3.40.1) [linux-any],
                libtiff-dev,
                libvulkan-dev [linux-any],
-               libwayland-dev (>= 1.20.0) [linux-any],
+               libwayland-dev (>= 1.21.0) [linux-any],
                libx11-dev,
                libxcomposite-dev,
                libxcursor-dev,
@@ -65,31 +68,25 @@
                meson (>= 0.59),
                pkg-config,
                python3-docutils <!nodoc>,
-               python3-gi (>= 3.40) <!nocheck>,
+               python3-gi (>= 3.40),
                sassc,
                ttf-bitstream-vera <!nocheck>,
-               wayland-protocols (>= 1.23) [linux-any],
+               wayland-protocols (>= 1.25) [linux-any],
                weston [linux-any] <!nocheck>,
                xauth <!nocheck>,
                xsltproc,
                xvfb <!nocheck>,
-Build-Depends-Indep: libcairo2-doc,
-                     gi-docgen,
-                     libglib2.0-doc,
-                     libpango1.0-doc,
+Build-Depends-Indep: gi-docgen <!nodoc>,
+                     libcairo2-doc <!nodoc>,
+                     libglib2.0-doc <!nodoc>,
+                     libpango1.0-doc <!nodoc>,
                      pandoc,
-                     python3 (>= 3.6) <!nodoc>,
-                     python3-jinja2 <!nodoc>,
-                     python3-markdown <!nodoc>,
-                     python3-pygments <!nodoc>,
-                     python3-toml <!nodoc>,
-                     python3-typogrify <!nodoc>,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4
 XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git
-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4/-/tree/ubuntu/jammy
-Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git -b ubuntu/jammy
+Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4/tree/ubuntu/master
+Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git -b ubuntu/master
 Homepage: https://www.gtk.org/
 
 Package: libgtk-4-1
@@ -179,7 +176,7 @@
          libcairo2-dev (>= 1.14.0),
          libegl1-mesa-dev [linux-any],
          libepoxy-dev (>= 1.0),
-         libfontconfig1-dev,
+         libfontconfig-dev,
          libgdk-pixbuf-2.0-dev (>= 2.30.0),
          libglib2.0-dev (>= 2.66.0),
          libgraphene-1.0-dev (>= 1.9.1),
@@ -270,7 +267,7 @@
          ${shlibs:Depends},
          libgtk-4-1 (= ${binary:Version})
 Recommends: fonts-cantarell,
-            librsvg2-common (>= 2.52.0),
+            librsvg2-common (>= 2.52.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64 riscv64 sparc64 x32],
 Description: example files for GTK 4
  GTK is a multi-platform toolkit for creating graphical user
  interfaces. Offering a complete set of widgets, GTK is suitable
@@ -285,7 +282,7 @@
 Section: x11
 Architecture: any
 Depends: iso-codes,
-         librsvg2-common (>= 2.52.0),
+         librsvg2-common (>= 2.52.0) [amd64 arm64 armel armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64 riscv64 sparc64 x32],
          ${misc:Depends},
          ${shlibs:Depends},
          libgtk-4-1 (= ${binary:Version}),
@@ -311,12 +308,3 @@
 Breaks: python-gi (<< 3.18),
         python3-gi (<< 3.18)
 Provides: gir1.2-gdk-4.0 (= ${binary:Version}),
-          gir1.2-gdkwayland-4.0 (= ${binary:Version}) [linux-any],
-          gir1.2-gdkx11-4.0 (= ${binary:Version}),
-          gir1.2-gsk-4.0 (= ${binary:Version})
-Description: GTK graphical user interface library -- gir bindings
- GTK is a multi-platform toolkit for creating graphical user
- interfaces. Offering a complete set of widgets, GTK is suitable
- for projects ranging from small one-off tools to complete application
- suites.
- .

=== debian/rules ===
--- 
+++ 
@@ -45,6 +45,7 @@
 export TESTS_PKG := gtk-$(APIVER)-tests
 
 # files larger than 4k in size will be compressed by dh_compress
+
 # so append a .gz suffix to avoid dangling symlinks
 export README_MD_MAYBE_GZ := README.md$(shell find -maxdepth 1 -size +4k -name README.md -exec echo ".gz" \;)
 
@@ -80,7 +81,7 @@
 
 configure_flags_deb = \
 	-Dauto_features=enabled \
-	-Dbroadway-backend=false \
+	-Dbroadway-backend=true \
 	-Dx11-backend=true \
 	${NULL}
 
@@ -217,6 +218,12 @@
 test_timeout_multiplier = 20
 endif
 
+ifneq ($(filter mips%,$(DEB_HOST_ARCH_CPU)),)
+$(info Disabling use of llvmpipe due to mips family CPU, see https://bugs.debian.org/993550)
+export GALLIUM_DRIVER=softpipe
+export LIBGL_ALWAYS_SOFTWARE=true
+endif
+
 fuzzy_gsk_compare = \
 	$(NULL)
 
@@ -252,28 +259,22 @@
 	skipped_suites += \
 		gsk-compare-broadway \
 		gsk-compare-gl \
-		gsk-compare-ngl \
 		$(NULL)
 endif
 
 override_dh_auto_test:
-	set -e; for backend in $(test_backends); do \
-		env BUILDDIR=debian/build/deb \
-			FUZZY_GSK_COMPARE="$(fuzzy_gsk_compare)" \
-			FUZZY_REFTESTS="$(fuzzy_reftests)" \
-			IGNORE_GSK_COMPARE="$(ignore_gsk_compare)" \
-			IGNORE_REFTESTS="$(ignore_reftests)" \
-			XFAIL_GSK_COMPARE="$(xfail_gsk_compare)" \
-			XFAIL_REFTESTS="$(xfail_reftests)" \
-			BACKEND=$$backend \
-				debian/run-tests.sh -t $(test_timeout_multiplier) \
-					$(addprefix --no-suite=,$(skipped_suites)); \
-	done
+	env \
+		BUILDDIR=debian/build/deb \
+		FUZZY_GSK_COMPARE="$(fuzzy_gsk_compare)" \
+		FUZZY_REFTESTS="$(fuzzy_reftests)" \
+		IGNORE_GSK_COMPARE="$(ignore_gsk_compare)" \
+		IGNORE_REFTESTS="$(ignore_reftests)" \
+		XFAIL_GSK_COMPARE="$(xfail_gsk_compare)" \
+		XFAIL_REFTESTS="$(xfail_reftests)" \
+		BACKENDS="$(test_backends)" \
+	debian/run-tests.sh -t $(test_timeout_multiplier) \
+		$(addprefix --no-suite=,$(skipped_suites)) \
+		$(NULL)
 
 override_dh_auto_install:
 	dh_auto_install --builddirectory=debian/build/deb --destdir=debian/install/deb
-ifneq ($(filter %-udeb,$(built_binaries)),)
-	dh_auto_install --builddirectory=debian/build/udeb --destdir=debian/install/udeb
-endif
-
-override_dh_install:

## gtk4 4.8.2+ds

=== debian/changelog ===
gtk4 (4.8.2+ds-3) unstable; urgency=medium

  * Skip border-image-excess-size reftest on big-endian machines.
    Mitigates: #1024391
  * Update to upstream gtk-4-8 branch commit 4.8.2-21-g753c6f2435
    - Trigger on-screen keyboard more reliably
    - Don't dismiss popups unnecessarily

 -- Simon McVittie <smcv@debian.org>  Fri, 18 Nov 2022 22:12:24 +0000

gtk4 (4.8.2+ds-2) unstable; urgency=medium

  * d/watch, d/gbp.conf: Only watch for 4.8.x versions.
    Development release 4.9.1 has already happened, but is unlikely to reach
    a stable branch before the Debian 12 freeze.
  * Build-/test-depend on dbus-daemon instead of dbus.
    We only need dbus-run-session here, not the system bus.
  * d/patches: Update to upstream gtk-4-8 branch commit 4.8.2-18-g205783d9b0
    - Fix handling of AltGr when multiple keyboard layouts use it
    - Fix handling of back/forward mouse buttons
    - Fix a focus handling regression
    - Fix a regression that caused a very narrow combo box drop-down in
      GNOME Settings since 4.8
    - Fix a regression with copying under Phosh since 4.8
    - Don't confine resized windows to the geometry of the first monitor
    - Translation updates

 -- Simon McVittie <smcv@debian.org>  Fri, 18 Nov 2022 09:56:14 +0000

gtk4 (4.8.2+ds-1) unstable; urgency=medium

  * New upstream release
  * d/control.in: Update Meson build-dependency
  * d/copyright: Stop listing wayland and wayland-protocols as excluded.
    They are no longer in the upstream source release.
  * d/patches: Remove patches that were applied upstream

 -- Simon McVittie <smcv@debian.org>  Sat, 29 Oct 2022 11:54:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: gtk4
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Simon McVittie <smcv@debian.org>, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>, Jeremy Bicha <jbicha@ubuntu.com>
+Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Uploaders: Simon McVittie <smcv@debian.org>, Jeremy Bicha <jbicha@ubuntu.com>
 Build-Depends: adwaita-icon-theme <!nocheck>,
                at-spi2-core <!nocheck>,
-               dbus <!nocheck>,
+               dbus-daemon <!nocheck>,
                debhelper-compat (= 13),
                dh-exec,
-               dh-sequence-translations,
                docbook-xml,
                docbook-xsl,
                dpkg-dev (>= 1.17.14),
@@ -65,7 +63,7 @@
                libxml2-utils,
                libxrandr-dev (>= 2:1.5.0),
                locales <!nocheck> | locales-all <!nocheck>,
-               meson (>= 0.59),
+               meson (>= 0.60),
                pkg-config,
                python3-docutils <!nodoc>,
                python3-gi (>= 3.40),
@@ -83,10 +81,8 @@
                      pandoc,
 Rules-Requires-Root: no
 Standards-Version: 4.6.1
-XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4
-XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git
-Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4/tree/ubuntu/master
-Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git -b ubuntu/master
+Vcs-Browser: https://salsa.debian.org/gnome-team/gtk4
+Vcs-Git: https://salsa.debian.org/gnome-team/gtk4.git
 Homepage: https://www.gtk.org/
 
 Package: libgtk-4-1
@@ -308,3 +304,9 @@
 Breaks: python-gi (<< 3.18),
         python3-gi (<< 3.18)
 Provides: gir1.2-gdk-4.0 (= ${binary:Version}),
+          gir1.2-gdkwayland-4.0 (= ${binary:Version}) [linux-any],
+          gir1.2-gdkx11-4.0 (= ${binary:Version}),
+          gir1.2-gsk-4.0 (= ${binary:Version})
+Description: GTK graphical user interface library -- gir bindings
+ GTK is a multi-platform toolkit for creating graphical user
+ interfaces. Offering a complete set of widgets, GTK is suitable

=== debian/rules ===
--- 
+++ 
@@ -45,7 +45,6 @@
 export TESTS_PKG := gtk-$(APIVER)-tests
 
 # files larger than 4k in size will be compressed by dh_compress
-
 # so append a .gz suffix to avoid dangling symlinks
 export README_MD_MAYBE_GZ := README.md$(shell find -maxdepth 1 -size +4k -name README.md -exec echo ".gz" \;)
 
@@ -253,6 +252,11 @@
 skipped_suites = \
 	$(NULL)
 
+# https://bugs.debian.org/1024391
+ifeq (big,$(DEB_HOST_ARCH_ENDIAN))
+	ignore_reftests += border-image-excess-size
+endif
+
 # TODO: Known failures: https://gitlab.gnome.org/GNOME/gtk/-/issues/4110
 # s390x: many (endianness?)
 ifeq (big,$(DEB_HOST_ARCH_ENDIAN))
@@ -276,5 +280,3 @@
 		$(addprefix --no-suite=,$(skipped_suites)) \
 		$(NULL)
 
-override_dh_auto_install:
-	dh_auto_install --builddirectory=debian/build/deb --destdir=debian/install/deb
